%
%-------------------------------------------------------------
%
%	ROBOTRAN - Version 6.6 (build : february 22, 2008)
%
%	Copyright 
%	Universite catholique de Louvain 
%	Departement de Mecanique 
%	Unite de Production Mecanique et Machines 
%	2, Place du Levant 
%	1348 Louvain-la-Neuve 
%	http://www.robotran.be// 
%
%	==> Generation Date : Tue Jan 28 11:13:43 2020
%
%	==> Project name : pendulum_spring_matlab
%	==> using XML input file 
%
%	==> Number of joints : 4
%
%	==> Function : F 1 : Direct Dynamics (Semi-Explicit formulation) : RNEA
%	==> Flops complexity : 91
%
%	==> Generation Time :  0.000 seconds
%	==> Post-Processing :  0.000 seconds
%
%-------------------------------------------------------------
%
function [M,c] = dirdyna(s,tsim,usrfun)

 M = zeros(4,4);
 c = zeros(4,1);

q = s.q; 
qd = s.qd; 
qdd = s.qdd; 
frc = s.frc; 
trq = s.trq; 

% === begin imp_aux === 

% === end imp_aux === 

% ===== BEGIN task 0 ===== 

% = = Block_0_0_0_0_0_1 = = 
 
% Augmented Joint Position Vectors   

  Dz23 = q(2)+s.dpt(3,3);
 
% Trigonometric Variables  

  C1 = cos(q(1));
  S1 = sin(q(1));

% = = Block_0_0_0_0_0_2 = = 
 
% Trigonometric Variables  

  C3 = cos(q(3));
  S3 = sin(q(3));
  C4 = cos(q(4));
  S4 = sin(q(4));

% = = Block_0_1_0_0_0_1 = = 
 
% Forward Kinematics 

  AlF11 = s.g(3)*S1;

% = = Block_0_1_0_0_0_2 = = 
 
% Forward Kinematics 

  BS93 = -qd(3)*qd(3);
  AlF13 = s.g(3)*S3;
  AlF33 = -s.g(3)*C3;
  OM24 = qd(3)+qd(4);

% = = Block_0_2_0_1_0_1 = = 
 
% Backward Dynamics 

  FA32 = -(s.frc(3,2)+s.m(2)*(qd(1)*qd(1)*Dz23+s.g(3)*C1));
  CF21 = -(s.trq(2,1)+s.trq(2,2)+Dz23*(s.frc(1,2)-s.m(2)*(AlF11+(2.0)*qd(1)*qd(2)))+s.l(3,1)*(s.frc(1,1)-s.m(1)*AlF11));
  CM21_1 = s.In(5,1)+s.m(1)*s.l(3,1)*s.l(3,1)+s.m(2)*Dz23*Dz23;

% = = Block_0_2_0_1_0_2 = = 
 
% Backward Dynamics 

  FA14 = -(s.frc(1,4)-s.m(4)*(AlF13*C4-S4*(AlF33+BS93*s.dpt(3,6))));
  CF24 = -(s.trq(2,4)-FA14*s.l(3,4));
  FB14_3 = s.m(4)*(s.l(3,4)+s.dpt(3,6)*C4);
  CM24_3 = s.In(5,4)+FB14_3*s.l(3,4);
  CM24_4 = s.In(5,4)+s.m(4)*s.l(3,4)*s.l(3,4);
  CF23 = -(s.trq(2,3)-CF24-s.dpt(3,6)*(FA14*C4-S4*(s.frc(3,4)-s.m(4)*(AlF13*S4-OM24*OM24*s.l(3,4)+C4*(AlF33+BS93*s.dpt(3,6)))))+s.l(3,3)*(...
 s.frc(1,3)-s.m(3)*AlF13));
  CM23_3 = s.In(5,3)+CM24_3+s.m(3)*s.l(3,3)*s.l(3,3)+s.dpt(3,6)*(s.m(4)*s.dpt(3,6)*S4*S4+FB14_3*C4);

% = = Block_0_3_0_0_0_0 = = 
 
% Symbolic Outputs  

  M(1,1) = CM21_1;
  M(2,2) = s.m(2);
  M(3,3) = CM23_3;
  M(3,4) = CM24_3;
  M(4,3) = CM24_3;
  M(4,4) = CM24_4;
  c(1) = CF21;
  c(2) = FA32;
  c(3) = CF23;
  c(4) = CF24;

% ====== END Task 0 ====== 

  

