%
%-------------------------------------------------------------
%
%	ROBOTRAN - Version 6.6 (build : february 22, 2008)
%
%	Copyright 
%	Universite catholique de Louvain 
%	Departement de Mecanique 
%	Unite de Production Mecanique et Machines 
%	2, Place du Levant 
%	1348 Louvain-la-Neuve 
%	http://www.robotran.be// 
%
%	==> Generation Date : Tue Jan 28 11:13:43 2020
%
%	==> Project name : pendulum_spring_matlab
%	==> using XML input file 
%
%	==> Number of joints : 4
%
%	==> Function : F 2 : Inverse Dynamics : RNEA
%	==> Flops complexity : 86
%
%	==> Generation Time :  0.000 seconds
%	==> Post-Processing :  0.000 seconds
%
%-------------------------------------------------------------
%
function [Qq] = invdyna(s,tsim,usrfun)

 Qq = zeros(4,1);

q = s.q; 
qd = s.qd; 
qdd = s.qdd; 
frc = s.frc; 
trq = s.trq; 

% === begin imp_aux === 

% === end imp_aux === 

% ===== BEGIN task 0 ===== 

% = = Block_0_0_0_0_0_1 = = 
 
% Augmented Joint Position Vectors   

  Dz23 = q(2)+s.dpt(3,3);
 
% Trigonometric Variables  

  C1 = cos(q(1));
  S1 = sin(q(1));

% = = Block_0_0_0_0_0_2 = = 
 
% Trigonometric Variables  

  C3 = cos(q(3));
  S3 = sin(q(3));
  C4 = cos(q(4));
  S4 = sin(q(4));

% = = Block_0_1_0_0_0_0 = = 
 
% Forward Kinematics 

  ALPHA11 = s.g(3)*S1;
  BS93 = -qd(3)*qd(3);
  ALPHA13 = s.g(3)*S3;
  ALPHA33 = -s.g(3)*C3;
  OM24 = qd(3)+qd(4);
  OMp24 = qdd(3)+qdd(4);
 
% Backward Dynamics 

  Fs14 = -(s.frc(1,4)-s.m(4)*(OMp24*s.l(3,4)+C4*(ALPHA13+qdd(3)*s.dpt(3,6))-S4*(ALPHA33+BS93*s.dpt(3,6))));
  Cq24 = -(s.trq(2,4)-s.In(5,4)*OMp24-Fs14*s.l(3,4));
  Cq23 = -(s.trq(2,3)-Cq24-qdd(3)*s.In(5,3)-s.dpt(3,6)*(Fs14*C4-S4*(s.frc(3,4)+s.m(4)*(OM24*OM24*s.l(3,4)-C4*(ALPHA33+BS93*s.dpt(3,6))-S4*(...
 ALPHA13+qdd(3)*s.dpt(3,6)))))+s.l(3,3)*(s.frc(1,3)-s.m(3)*(ALPHA13+qdd(3)*s.l(3,3))));
  Fs32 = -(s.frc(3,2)-s.m(2)*(qdd(2)-qd(1)*qd(1)*Dz23-s.g(3)*C1));
  Cq21 = -(s.trq(2,1)+s.trq(2,2)-qdd(1)*s.In(5,1)+Dz23*(s.frc(1,2)-s.m(2)*(ALPHA11+(2.0)*qd(1)*qd(2)+qdd(1)*Dz23))+s.l(3,1)*(s.frc(1,1)-s.m(1)*(...
 ALPHA11+qdd(1)*s.l(3,1))));

% = = Block_0_2_0_0_0_0 = = 
 
% Symbolic Outputs  

  Qq(1) = Cq21;
  Qq(2) = Fs32;
  Qq(3) = Cq23;
  Qq(4) = Cq24;

% ====== END Task 0 ====== 

  

