#
#-------------------------------------------------------------
#
#	ROBOTRAN - Version 6.6 (build : february 22, 2008)
#
#	Copyright 
#	Universite catholique de Louvain 
#	Departement de Mecanique 
#	Unite de Production Mecanique et Machines 
#	2, Place du Levant 
#	1348 Louvain-la-Neuve 
#	http://www.robotran.be// 
#
#	==> Generation Date : Mon Jan 27 11:51:33 2020
#
#	==> Project name : pendulum_spring_python
#	==> using XML input file 
#
#	==> Number of joints : 4
#
#	==> Function : F 8 : Constraints Vector (h) and Jacobian Matrix (Jac) 
#	==> Flops complexity : 26
#
#	==> Generation Time :  0.000 seconds
#	==> Post-Processing :  0.000 seconds
#
#-------------------------------------------------------------
#
import numpy as np  

def cons_hJ(h,Jac,s):   
  q = s.q
  qd = s.qd
  qdd = s.qdd

# === begin imp_aux === 

# === end imp_aux === 

# ===== BEGIN task 0 ===== 

# = = Block_0_0_0_0_0_1 = = 
 
# Trigonometric Variables  

  C1 = np.cos(q[1])
  S1 = np.sin(q[1])

# = = Block_0_0_0_0_0_2 = = 
 
# Trigonometric Variables  

  C3 = np.cos(q[3])
  S3 = np.sin(q[3])
  C4 = np.cos(q[4])
  S4 = np.sin(q[4])

# = = Block_0_1_0_0_0_1 = = 
 
# Constraints and Constraints Jacobian 

#
  RL_0_15 = s.dpt[3,4]*S1
  RL_0_35 = s.dpt[3,4]*C1

# = = Block_0_1_0_0_0_2 = = 
 
# Trigonometric Variables  

#
  S3p4 = C3*S4+S3*C4
  C3p4 = C3*C4-S3*S4
 
# Constraints and Constraints Jacobian 

  RL_1_14 = s.dpt[3,6]*S3
  RL_1_34 = s.dpt[3,6]*C3
  RL_1_16 = s.dpt[3,7]*S3p4
  RL_1_36 = s.dpt[3,7]*C3p4
  JT_1_16_3 = RL_1_34+RL_1_36
  JT_1_36_3 = -(RL_1_14+RL_1_16)

# = = Block_0_1_0_0_1_0 = = 
 
# Constraints and Constraints Jacobian 

#
  h_1 = RL_0_15-RL_1_14-RL_1_16-s.dpt[1,2]
  h_3 = RL_0_35-RL_1_34-RL_1_36

# = = Block_0_3_0_0_0_0 = = 
 
# Symbolic Outputs  

  h[1] = h_1
  h[2] = h_3
  Jac[1,1] = RL_0_35
  Jac[1,3] = -JT_1_16_3
  Jac[1,4] = -RL_1_36
  Jac[2,1] = -RL_0_15
  Jac[2,3] = -JT_1_36_3
  Jac[2,4] = RL_1_16

# ====== END Task 0 ====== 

  

