# -*- coding: utf-8 -*-

#JOINT_FORCES.PY
#@author: Thomas Gillis
#
#Created on 1/7/2013
#Last update on 3/7/2013
#
#Copyright 2013 Universite Catholique de Louvain


import numpy as np

def user_JointForces(mbs,tsim):
    """ Compute the force in the joint. it fill the Qq matrix.
    
    :param mbs: The mbs Data structure
    :param tsim: the simulation time
    
    """
    
    #mise par default a zero de toutes les forces
    #mbs.Qq=np.zeros(mbs.Qq.shape)
    mbs.Qq[:] = 0
    
#==============================================================================
# BEGIN OF USER CODE
#==============================================================================

    # set the joint force in joint 2
    id = mbs.joint_id["T3_slider"]
    K = 100
    C = 2
    L0 = 0.1
    mbs.Qq[id] = - ( K*(mbs.q[id]-L0) + C*mbs.qd[id] )

#==============================================================================
# END OF USER CODE
#==============================================================================
